/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-04 10:53
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MAXN = 1e6 + 5;
const ll INF = 1LL << 60;

// from reference
vector<int> edges[MAXN], up[MAXN];
vector<int> ti(MAXN), to(MAXN), de(MAXN);
int t = 0, root;
void dfs_lca(int u, int p, int d = 1){
  ti[u] = ++t, de[u] = d, up[u] = {p};
  for(int i = 0; (2 << i) < d; i++)
    up[u].push_back(up[up[u][i]][i]);
  for(int v : edges[u])
    if(v != p) dfs_lca(v, u, d + 1);
  to[u] = ++t;
}
bool is_anc(int p, int u){
  return ti[p] <= ti[u] and to[p] >= to[u];
}
int lca(int a, int b){
  if(is_anc(a, b)) return a;
  for(int k = size(up[a]) - 1; k >= 0; k--)
    if(!is_anc(up[a][k], b))
      a = up[a][k], k = size(up[a]);
  return up[a][0];
}
int dist(int a, int b){
  return de[a] + de[b] - 2 * de[lca(a, b)];
}
// from reference 

ll H, W;

void addedge(int x, int y){
    edges[x].push_back(y);
    edges[y].push_back(x);
}

void solve(){
    // Code goes here ...
    cin >> H >> W;

    vector<vector<int>> grid(H, vector<int>(W, 0));

    int vid = 0;
    string row, lastrow;
    getline(cin, row);
    getline(cin, row);
    R(i, H){
        lastrow = row;
        getline(cin, row);
        R(j, W){
            int jpos = 2 * j + 1;
            grid[i][j] = vid;

            if(i > 0 and lastrow[jpos] != '_')
                addedge(vid, vid - W);
            if(j > 0 and row[jpos - 1] != '|')
                addedge(vid, vid - 1);

            vid++;
        }
    }


    int M;
    cin >> M;

    vector<int> xs(M), ys(M);
    R(i, M) cin >> xs[i] >> ys[i];

    vector<pii> qs(M-1);
    R(i, M - 1)
        qs[i] = {
            grid[xs[i] - 1][ys[i] - 1],
            grid[xs[i + 1] - 1][ys[i + 1] - 1]
        };


    // usage
    dfs_lca(0, 0);
    ll res = 0;
    for(auto [a, b] : qs)
        res += dist(a, b);
    // usage

    cout << res << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    solve();

    return 0;
}
        
